package com.finecosoft.aop.aspectj;

import java.util.Date;

import org.aspectj.lang.ProceedingJoinPoint;
import org.aspectj.lang.annotation.Around;
import org.aspectj.lang.annotation.Aspect;

@Aspect
public class AnnotatedLogInterceptor {

	@Around("execution(* longRunningMethod(..))")
	public Object log(ProceedingJoinPoint jp) throws Throwable {
		System.out.println("Start executing " + jp.getSignature().getName() + " at " + new Date());
		Object value = jp.proceed();
		System.out.println("End executing " + jp.getSignature().getName() + " at " + new Date());
		return value;
	}
}
