package com.finecosoft.aop.introduction;

import org.aspectj.lang.annotation.Aspect;
import org.aspectj.lang.annotation.Before;
import org.aspectj.lang.annotation.DeclareParents;

@Aspect
public class MethodCallCounterAspect {
	@DeclareParents(value = "com.finecosoft.aop.introduction.ToBeExtendedService+",
			defaultImpl=MethodCallCounterImpl.class)
	public static MethodCallCounter mixin;
	
	@Before(value="execution(* com.finecosoft.aop.introduction.ToBeExtendedService.someMethod(..)) && this(methodCallCounter)",
			argNames="methodCallCounter")
	public void countMethodCall(MethodCallCounter methodCallCounter) {
		methodCallCounter.count();
	}
}
