package com.finecosoft.aop.pointcutprogrammed.dynamicpc;

import java.lang.reflect.Method;

import org.springframework.aop.ClassFilter;
import org.springframework.aop.support.DynamicMethodMatcherPointcut;

import com.finecosoft.aop.pointcutprogrammed.ToBeDecoratedClass;

public class DynamicPointcut extends DynamicMethodMatcherPointcut {
	@Override
	public boolean matches(Method method, Class<?> clazz) {
		return method.getName().equals("printInteger");
	}
	
	@Override
	public boolean matches(Method method, Class<?> clazz, Object[] args) {
		if (args.length == 0)
			return false;
		
		Object obj = args[0];
		if (obj instanceof Integer) {
			return (Integer) obj > 10;
		}
		else
			return false;
	}

	@Override
	public ClassFilter getClassFilter() {
		return new ClassFilter() {
			
			@Override
			public boolean matches(Class<?> clazz) {
				return clazz == ToBeDecoratedClass.class;
			}
		};
	}
}
