package com.finecosoft.aop.pointcutprogrammed.staticpc;

import org.aopalliance.aop.Advice;
import org.springframework.aop.Advisor;
import org.springframework.aop.Pointcut;
import org.springframework.aop.framework.ProxyFactory;
import org.springframework.aop.support.DefaultPointcutAdvisor;

import com.finecosoft.aop.pointcutprogrammed.LogInterceptor;
import com.finecosoft.aop.pointcutprogrammed.NotToBeDecoratedClass;
import com.finecosoft.aop.pointcutprogrammed.ToBeDecoratedClass;

public class StaticPointcutExample {
	public static void main(String[] args) {
		ToBeDecoratedClass toBeDecoratedClass = new ToBeDecoratedClass();
		NotToBeDecoratedClass notToBeDecoratedClass = new NotToBeDecoratedClass();
		
		ToBeDecoratedClass proxyDecoratedClass;
		NotToBeDecoratedClass proxyNotDecoratedClass;
		
		Pointcut pointcut = new StaticPointcut();
		Advice advice = new LogInterceptor();
		Advisor advisor = new DefaultPointcutAdvisor(pointcut, advice);
		
		ProxyFactory proxyFactory = new ProxyFactory();
		proxyFactory.addAdvisor(advisor);
		proxyFactory.setTarget(toBeDecoratedClass);
		
		proxyDecoratedClass = (ToBeDecoratedClass) proxyFactory.getProxy();
		
		proxyFactory = new ProxyFactory();
		proxyFactory.addAdvisor(advisor);
		proxyFactory.setTarget(notToBeDecoratedClass);
		
		proxyNotDecoratedClass = (NotToBeDecoratedClass) proxyFactory.getProxy();
		
		proxyDecoratedClass.rundomSleep();
		proxyNotDecoratedClass.rundomSleep();
		proxyDecoratedClass.printInteger(25);
		proxyNotDecoratedClass.printInteger(25);
	}
}
